<template>
    <div v-if="!pendingUserInfo" class="bonuses-page">
        <div
                v-if="!hasAccess">
            <div class="alert-container">
                <ob-alert
                        text="Ошибка доступа"
                        :hide-close-button="true"
                        theme="danger"/>
            </div>
        </div>
        <ob-modal
                ref="modal-error"
                :title="'Ошибка на сервере'"
                :isShowControls="true"
                :isReadOnly="true"
        >Данные не сохранены
        </ob-modal>
        <ob-modal
                ref="modal-success"
                :title="'Данные сохранены'"
                :isShowControls="true"
                :isReadOnly="true"
        >
        </ob-modal>
        <ob-modal
                ref="modal-delete"
                :isError="true"
                okText="Да"
                :title="'Удалить методику?'"
                :isShowControls="true"
                @submit="deleteCurrentBonusMethodology"
        >
        </ob-modal>
        <two-panes
                v-if="hasAccess"
                :left-caption="'UI ведения справочника Методики бонусных программ'"
                :right-caption="''">
            <template slot="left">
                <div class="ratings">
                    <ob-table
                            class="ratings__column"
                            :columns="methodColumns"
                            :items="gridData"
                            :functionalPanel="true"
                            :showAddButton="true"
                            :addButtonText="'Добавить методику'"

                            @select="selectHandler"
                            @add="openPopup()"
                    />
                </div>
                <create ref="constructorPopup"/>
            </template>
            <template slot="right">
                <div
                        v-if="!currentMethodology"
                        class="no-item">
                    Методология не выбрана
                </div>
                <div
                        v-if="currentMethodology"
                        class="settings-wrapper">
                    <div class="settings-gutter">
                        <!-- <div class="settings-title">Настройка методики бонусной программы</div> -->
                        <ob-form
                                v-if="currentMethodology && !isDataPending"
                                class="settings-form"
                                :formData="currentMethodologyFormData"
                                @cancel="resetFormToCurrent"
                                @submit="submitEdit"
                                :isCancelDisabled="true"
                                cancelText="Исходные"
                                ref="form"
                                :isOnlySubmit="wasActivated"
                        >
                            <template slot="title">
                                <strong>Настройка методики бонусной программы</strong>
                            </template>
                            <div class="input-container edit-method">
                                <ob-input
                                        class="edit-method__input"
                                        v-model="currentMethodologyFormData.name"
                                        :label="'Наименование'"
                                        :placeholder="'Введите'"
                                        type="text"
                                        :disabled="wasActivated"
                                />
                                <ob-checkbox
                                        :class="{ 'edit-method__check': true, 'color_green' : currentMethodologyFormData.isActive, 'color_red' : !currentMethodologyFormData.isActive }"
                                        v-model="currentMethodologyFormData.isActive"
                                        label="Активность"
                                        :disabled="wasActivated"
                                />
                            </div>
                            <div class="input-container">
                                <ob-selector
                                        :placeholder="'Выберите'"
                                        :disabled="wasActivated"
                                        :items="$store.state.bonus_activities.items"
                                        displayExp="name"
                                        v-model="currentMethodologyFormData.participantActivityUuid"
                                        :label="'Направление деятельности'"
                                />
                            </div>
                            <div class="input-container">
                                <ob-textarea
                                        v-model="currentMethodologyFormData.description"
                                        :placeholder="'Введите'"
                                        :label="'Краткое описание'"
                                        :disabled="wasActivated"
                                />
                            </div>
                        </ob-form>
                        <div class="delete-button-container">
                            <ob-button
                                v-if="!isDataPending && !currentBonusMethodologyStartActivityDate"
                                label="Удалить"
                                :danger="true"
                                @click="$refs['modal-delete'].open()"
                            />
                        </div>
                        <div>
                            <div class="add-bonus">
                                <ob-checkbox
                                        class="add-bonus__switch"
                                        v-model="currentBonusesParamsActivity.inRangeValues"
                                        :label="'Включить бонусы за длительность пребывания в коридорах значений рейтинга'"
                                        :disabled="wasActivated"
                                />
                                <span class="add-bonus__header">Длительности пребывания в коридорах значений рейтинга</span>
                                <div class="add-bonus__container">
                                    <div class="inputs-flex-container">
                                        <div class="add-bonus__input-wrapper">
                                            <ob-input
                                                    class="add-bonus__input"
                                                    :label="'Количество интервалов'"
                                                    :placeholder="'Введите'"
                                                    :disabled="true"
                                                    type="text"
                                                    v-model="currentMethodologyFormData.inRangeValues.intervals"
                                            />
                                            <i
                                                    v-show="currentBonusesParamsActivity.inRangeValues"
                                                    class="add-bonus__add-row icon plus"
                                                    @click="addRow('inRangeValues')"></i>
                                        </div>
                                        <div class="add-bonus__input-wrapper">
                                            <ob-input
                                                    v-if="!isDataPending"
                                                    class="add-bonus__input"
                                                    :label="'Количество начисления, дней'"
                                                    :placeholder="'Введите'"
                                                    :isDirtyForce="currentMethodologyFormData.inRangeValues.periodIsDirty"
                                                    :isValid="currentMethodologyFormData.inRangeValues.periodIsValid"
                                                    :disabled="!currentBonusesParamsActivity.inRangeValues"
                                                    v-model="currentMethodologyFormData.inRangeValues.period"
                                                    type="text"
                                            />
                                        </div>
                                    </div>
                                    <table
                                            v-if="currentMethodologyFormData.inRangeValues.intervals"
                                            class="bonus-table">
                                        <thead class="bonus-table__header">
                                            <tr class="bonus-table__header">
                                                <td class="bonus-table__header-item">
                                                    Минимальный период, недель
                                                </td>
                                                <td class="bonus-table__header-item">
                                                    Значение рейтинга
                                                </td>
                                                <td class="bonus-table__header-item">
                                                    Количество бонусов
                                                </td>
                                                <td></td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr class="bonus-table__input-row" v-for="(row, index) in currentMethodologyFormData.inRangeValues.values" :key="row.id">
                                                <td class="bonus-table__input-cell">
                                                    <input
                                                            class="bonus-table__input"
                                                            type="text"
                                                            placeholder="Добавьте"
                                                            :disabled="!currentBonusesParamsActivity.inRangeValues"
                                                            :value="row.min"
                                                            @keyup="setChangedValue($event, index, 'inRangeValues', 'min')">
                                                </td>
                                                <td class="bonus-table__input-cell">
                                                    <input
                                                            class="bonus-table__input"
                                                            type="text"
                                                            placeholder="Введите"
                                                            :disabled="!currentBonusesParamsActivity.inRangeValues"
                                                            :value="row.rating"
                                                            @keyup="setChangedValue($event, index, 'inRangeValues', 'rating')">
                                                </td>
                                                <td class="bonus-table__input-cell">
                                                    <input
                                                            class="bonus-table__input"
                                                            type="text"
                                                            placeholder="Введите"
                                                            :disabled="!currentBonusesParamsActivity.inRangeValues"
                                                            :value="row.bonus"
                                                            @keyup="setChangedValue($event, index, 'inRangeValues', 'bonus')">
                                                </td>
                                                <td
                                                        class="add-bonus__remove-row-cell"
                                                        :class="{ 'disabled' : !currentBonusesParamsActivity.inRangeValues }">
                                                    <i
                                                            v-show="currentBonusesParamsActivity.inRangeValues"
                                                            class="add-bonus__remove-row icon minus"
                                                            @click="removeRow('inRangeValues', index)"></i>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>


                            </div>

                            <div class="add-bonus">
                                <ob-checkbox
                                        class="add-bonus__switch"
                                        v-model="currentBonusesParamsActivity.ratingIncrease"
                                        :label="'Включить бонусы за повышение рейтинга'"
                                        :disabled="wasActivated"
                                />
                                <span class="add-bonus__header">Коридоры повышения рейтинга</span>
                                <div class="add-bonus__container">
                                    <div class="inputs-flex-container">
                                        <div class="add-bonus__input-wrapper">
                                            <ob-input
                                                    class="add-bonus__input"
                                                    :label="'Количество интервалов'"
                                                    :placeholder="'Введите'"
                                                    :disabled="true"
                                                    type="text"
                                                    v-model="currentMethodologyFormData.ratingIncrease.intervals"
                                            />
                                            <i
                                                    v-show="currentBonusesParamsActivity.ratingIncrease"
                                                    class="add-bonus__add-row icon plus"
                                                    @click="addRow('ratingIncrease')"></i>
                                        </div>
                                        <div class="add-bonus__input-wrapper">
                                            <ob-input
                                                    v-if="!isDataPending"
                                                    class="add-bonus__input"
                                                    :label="'Память о переходах, дней'"
                                                    :placeholder="'Введите'"
                                                    :disabled="!currentBonusesParamsActivity.ratingIncrease"
                                                    :isDirtyForce="currentMethodologyFormData.ratingIncrease.transitionMemberIsDirty"
                                                    :isValid="currentMethodologyFormData.ratingIncrease.transitionMemberIsValid"
                                                    v-model="currentMethodologyFormData.ratingIncrease.transitionMember"
                                                    type="text"
                                            />
                                        </div>
                                    </div>
                                    <table
                                            v-if="currentMethodologyFormData.ratingIncrease.intervals"
                                            class="bonus-table">
                                        <thead class="bonus-table__header">
                                        <tr class="bonus-table__header">
                                            <td class="bonus-table__header-item">
                                                Значение рейтинга
                                            </td>
                                            <td class="bonus-table__header-item">
                                                Количество бонусов
                                            </td>
                                            <td></td>
                                        </tr>
                                        </thead>
                                        <tbody>
                                            <tr class="bonus-table__input-row" v-for="(row, index) in currentMethodologyFormData.ratingIncrease.values" :key="row.id">
                                                <td class="bonus-table__input-cell">
                                                    <input
                                                        class="bonus-table__input"
                                                        type="text"
                                                        placeholder="Добавьте"
                                                        :disabled="!currentBonusesParamsActivity.ratingIncrease"
                                                        :value="row.rating"
                                                        @keyup="setChangedValue($event, index, 'ratingIncrease', 'rating')">
                                                </td>
                                                <td class="bonus-table__input-cell">
                                                    <input
                                                        class="bonus-table__input"
                                                        type="text"
                                                        placeholder="Добавьте"
                                                        :disabled="!currentBonusesParamsActivity.ratingIncrease"
                                                        :value="row.bonus"
                                                        @keyup="setChangedValue($event, index, 'ratingIncrease', 'bonus')">
                                                </td>
                                                <td
                                                        class="add-bonus__remove-row-cell"
                                                        :class="{ 'disabled' : !currentBonusesParamsActivity.ratingIncrease }">
                                                    <i
                                                        v-show="currentBonusesParamsActivity.ratingIncrease"
                                                        class="add-bonus__remove-row icon minus"
                                                        @click="removeRow('ratingIncrease', index)"></i>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>

                            <div class="add-bonus">
                                <ob-checkbox
                                        class="add-bonus__switch"
                                        v-model="currentBonusesParamsActivity.completeOrder"
                                        :label="'Включить бонусы за выполнение заказов'"
                                        :disabled="wasActivated"
                                />
                                <span class="add-bonus__header">Коридоры выполнения заказов</span>
                                <div class="add-bonus__container">
                                    <div class="inputs-flex-container">
                                        <div class="add-bonus__input-wrapper">
                                            <ob-input
                                                    class="add-bonus__input"
                                                    :label="'Количество интервалов'"
                                                    :placeholder="'Введите'"
                                                    :disabled="true"
                                                    type="text"
                                                    v-model="currentMethodologyFormData.completeOrder.intervals"
                                            />
                                            <i
                                                    v-show="currentBonusesParamsActivity.completeOrder"
                                                    class="add-bonus__add-row icon plus"
                                                    @click="addRow('completeOrder')"></i>
                                        </div>
                                    </div>
                                    <table
                                            v-if="currentMethodologyFormData.completeOrder.intervals"
                                            class="bonus-table">
                                        <thead class="bonus-table__header">
                                        <tr class="bonus-table__header">
                                            <td class="bonus-table__header-item">
                                                Значение рейтинга
                                            </td>
                                            <td class="bonus-table__header-item">
                                                Количество бонусов
                                            </td>
                                            <td></td>
                                        </tr>
                                        </thead>
                                        <tbody>
                                        <tr class="bonus-table__input-row" v-for="(row, index) in currentMethodologyFormData.completeOrder.values" :key="row.id">
                                            <td class="bonus-table__input-cell">
                                                <input
                                                        class="bonus-table__input"
                                                        type="text"
                                                        placeholder="Добавьте"
                                                        :disabled="!currentBonusesParamsActivity.completeOrder"
                                                        :value="row.rating"
                                                        @keyup="setChangedValue($event, index, 'completeOrder', 'rating')">
                                            </td>
                                            <td class="bonus-table__input-cell">
                                                <input
                                                        class="bonus-table__input"
                                                        type="text"
                                                        placeholder="Добавьте"
                                                        :disabled="!currentBonusesParamsActivity.completeOrder"
                                                        :value="row.bonus"
                                                        @keyup="setChangedValue($event, index, 'completeOrder', 'bonus')">
                                            </td>
                                            <td
                                                    class="add-bonus__remove-row-cell"
                                                    :class="{ 'disabled' : !currentBonusesParamsActivity.completeOrder }">
                                                <i
                                                    v-show="currentBonusesParamsActivity.completeOrder"
                                                    class="add-bonus__remove-row icon minus"
                                                    @click="removeRow('completeOrder', index)"></i>
                                            </td>
                                        </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </template>
        </two-panes>
    </div>
</template>

<script>

    // Common components
    import ObTable from "common-components/src/obComponents/obTable";
    import ObButton from "common-components/src/obComponents/obButton";
    import TwoPanes from "common-components/src/obComponents/obTwoPanels";
    import ObAlert from "common-components/src/obComponents/obAlert";
    import ObForm from 'common-components/src/obComponents/obForm';
    import ObInput from 'common-components/src/obComponents/obInput';
    import ObSelector from 'common-components/src/obComponents/obSelect';
    import ObTextarea from 'common-components/src/obComponents/obTextarea';
    import ObCheckbox from 'common-components/src/obComponents/obCheckbox';
    import ObModal from "common-components/src/obComponents/obModal";
    import moment from 'moment';


    // Local components
    import create from './modal/create';

    // Store actions and mutations
    import {GET_BONUSES, GET_USER_INFO} from '../../store/modules/bonus_methodologies';
    import {GET_BONUS, UPDATE_BONUS, DELETE_BONUS} from '../../store/modules/bonus_methodology';

    export default {
        components: {
            TwoPanes,
            ObTable,
            create,
            ObAlert,
            ObForm,
            ObInput,
            ObSelector,
            ObTextarea,
            ObCheckbox,
            ObModal,
            ObButton
        },
        data() {
            return {
                methodColumns: [
                    {
                        title: 'Название',
                        key: 'name'
                    },
                    {
                        title: 'Дата создания',
                        key: 'createDt',
                        sort: "datetime",
                        html: ({createDt}) => this.getDatetimeHtml(createDt)
                    },
                    {
                        title: 'Дата начала действия',
                        key: 'startActivityDt',
                        sort: "datetime",
                        html: ({startActivityDt}) => this.getDatetimeHtml(startActivityDt)
                    },
                    {
                        title: 'Дата окончания действия',
                        key: 'endActivityDt',
                        sort: "datetime",
                        html: ({endActivityDt}) => this.getDatetimeHtml(endActivityDt)
                    },
                    {
                        title: 'Активность',
                        key: 'status'
                    }
                ],
                currentMethodologyFormData: {
                    isSubmitDisabled: false,
                    isCancelDisabled: false,
                    uuid: '',
                    name: '',
                    activity: '',
                    participantActivityUuid: '',
                    description: '',
                    isActive: undefined,
                    inRangeValues: {
                        intervals: '',
                        period: 0,
                        periodIsValid: true,
                        periodIsDirty: false,
                        values: []
                    },
                    ratingIncrease: {
                        intervals: '',
                        transitionMember: 0,
                        transitionMemberIsValid: true,
                        transitionMemberIsDirty: false,
                        values: []
                    },
                    completeOrder: {
                        intervals: '',
                        values: []
                    }
                },
                isCurrentMethodologyFormValid: true,
                currentBonusesParamsActivity: {
                    inRangeValues: false,
                    ratingIncrease: false,
                    completeOrder: false
                },
                isDataPending: false
            }
        },
        computed: {
            gridData() {
                const data = this.$store.getters.getBonusMethodologies;
                const preparedData = [];
                for (let i = 0; i < data.length; i++) {
                    const item = data[i];
                    preparedData.push({
                        uuid: item.uuid,
                        name: item.name,
                        createDt: item.createDt,
                        startActivityDt: item.startActivityDt,
                        endActivityDt: item.endActivityDt,
                        status: (item.status === 'ACTIVE') ? '<b style="color: green">Активна</b>' : ''
                    });
                }
                return preparedData;
            },
            currentMethodology() {
                return this.$store.getters.getCurrentBonusMethodology;
            },
            hasAccess() {
                const userRole = this.$store.getters.getUserRole;
                return (userRole === 'moderator' || userRole === 'expeditor')
            },
            pendingUserInfo() {
                return !this.$store.getters.getUserInfo;
            },
            preparedFormData() {
                const data = {
                    name: this.currentMethodologyFormData.name,
                    description: this.currentMethodologyFormData.description,
                    participantActivityUuid: this.currentMethodologyFormData.participantActivityUuid,
                    status: this.currentMethodologyFormData.isActive ? 'ACTIVE' : 'NOT_ACTIVE',
                };
                data.algorithms = {};
                if (this.currentMethodologyFormData.inRangeValues.intervals) {
                    const inRangeValues = [];
                    for (let i = 0; i < this.currentMethodologyFormData.inRangeValues.values.length; i++) {
                        const item = this.currentMethodologyFormData.inRangeValues.values[i];
                        inRangeValues.push({
                            min: item.min,
                            rating: item.rating,
                            bonus: item.bonus
                        });
                    }
                    data.algorithms.inRangeValues = {
                        values: inRangeValues,
                        period: this.currentMethodologyFormData.inRangeValues.period
                    }
                } else {
                    data.algorithms.inRangeValues = null
                }
                if (this.currentMethodologyFormData.ratingIncrease.intervals) {
                    const ratingIncreaseValues = [];
                    for (let i = 0; i < this.currentMethodologyFormData.ratingIncrease.values.length; i++) {
                        const item = this.currentMethodologyFormData.ratingIncrease.values[i];
                        ratingIncreaseValues.push({
                            rating: item.rating,
                            bonus: item.bonus
                        });
                    }
                    data.algorithms.ratingIncrease = {
                        values: ratingIncreaseValues,
                        transitionMember: this.currentMethodologyFormData.ratingIncrease.transitionMember
                    }
                } else {
                    data.algorithms.ratingIncrease = null
                }
                if (this.currentMethodologyFormData.completeOrder.intervals) {
                    const completeOrderValues = [];
                    for (let i = 0; i < this.currentMethodologyFormData.completeOrder.values.length; i++) {
                        const item = this.currentMethodologyFormData.completeOrder.values[i];
                        completeOrderValues.push({
                            rating: item.rating,
                            bonus: item.bonus
                        });
                    }
                    data.algorithms.completeOrder = {
                        values: completeOrderValues
                    }
                } else {
                    data.algorithms.completeOrder = null
                }
                return data;
            },
            currentBonusMethodologyStartActivityDate() {
                return this.$store.getters.getCurrentBonusMethodologyStartActivityDate;
            },
            wasActivated() {
                return Boolean(this.currentBonusMethodologyStartActivityDate);
            },
        },
        async created() {
            await this.$store.dispatch(GET_USER_INFO);
            this.$store.dispatch(GET_BONUSES);
        },
        methods: {
            makeId(length = 10) {
                let result = '';
                let characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
                let charactersLength = characters.length;
                for (let i = 0; i < length; i++) {
                    result += characters.charAt(Math.floor(Math.random() * charactersLength));
                }
                return result;
            },
            getDatetimeHtml (datetime) {
                return datetime ? `
                        <div class="field-datetime">
                            <div>${moment(datetime).locale('ru').format('L')}</div>
                            <div class="field-time">${moment(datetime).locale('ru').format('LT')}</div>
                        </div>
                    ` : ''
            },
            validateForm() {
                this.isCurrentMethodologyFormValid = true;
                if (this.preparedFormData.algorithms.inRangeValues && !this.preparedFormData.algorithms.inRangeValues.period) {
                    this.isCurrentMethodologyFormValid = false;
                    this.currentMethodologyFormData.inRangeValues.periodIsValid = false;
                    this.currentMethodologyFormData.inRangeValues.periodIsDirty = true;
                }
                if (this.preparedFormData.algorithms.ratingIncrease && !this.preparedFormData.algorithms.ratingIncrease.transitionMember) {
                    this.isCurrentMethodologyFormValid = false;
                    this.currentMethodologyFormData.ratingIncrease.transitionMemberIsValid = false;
                    this.currentMethodologyFormData.ratingIncrease.transitionMemberIsDirty = true;
                }

            },
            openPopup(uuid) {
                this.$refs['constructorPopup'].open(uuid);
            },
            disableBonusSettings() {
                this.currentBonusesParamsActivity.inRangeValues = false;
                this.currentBonusesParamsActivity.ratingIncrease = false;
                this.currentBonusesParamsActivity.completeOrder = false;
            },
            updateForm(currentMethodologyData) {
                this.currentMethodologyFormData.uuid = currentMethodologyData.uuid;
                this.currentMethodologyFormData.name = currentMethodologyData.name;
                this.currentMethodologyFormData.description = currentMethodologyData.description;
                this.currentMethodologyFormData.participantActivityUuid = currentMethodologyData.participantActivityUuid;
                if (currentMethodologyData.status === 'ACTIVE') {
                    this.currentMethodologyFormData.isActive = true;
                }
                if (currentMethodologyData.status === 'NOT_ACTIVE') {
                    this.currentMethodologyFormData.isActive = false;
                }

                if (currentMethodologyData.algorithms.inRangeValues) {
                    this.currentMethodologyFormData.inRangeValues.period = currentMethodologyData.algorithms.inRangeValues.period;
                    this.currentMethodologyFormData.inRangeValues.values = currentMethodologyData.algorithms.inRangeValues.values;
                    for (let i = 0; i < this.currentMethodologyFormData.inRangeValues.values.length; i++) {
                        const item = this.currentMethodologyFormData.inRangeValues.values[i];
                        item.id = this.makeId();
                    }
                    this.currentMethodologyFormData.inRangeValues.intervals = this.currentMethodologyFormData.inRangeValues.values.length
                } else {
                    this.currentMethodologyFormData.inRangeValues.values = [];
                    this.currentMethodologyFormData.inRangeValues.intervals = 0;
                    this.currentMethodologyFormData.inRangeValues.period = ''
                }

                if (currentMethodologyData.algorithms.ratingIncrease) {
                    this.currentMethodologyFormData.ratingIncrease.transitionMember = currentMethodologyData.algorithms.ratingIncrease.transitionMember
                    this.currentMethodologyFormData.ratingIncrease.values = currentMethodologyData.algorithms.ratingIncrease.values
                    for (let i = 0; i < this.currentMethodologyFormData.ratingIncrease.values.length; i++) {
                        const item = this.currentMethodologyFormData.ratingIncrease.values[i];
                        item.id = this.makeId();
                    }
                    this.currentMethodologyFormData.ratingIncrease.intervals = this.currentMethodologyFormData.ratingIncrease.values.length
                } else {
                    this.currentMethodologyFormData.ratingIncrease.values = [];
                    this.currentMethodologyFormData.ratingIncrease.intervals = 0;
                    this.currentMethodologyFormData.ratingIncrease.transitionMember = ''
                }

                if (currentMethodologyData.algorithms.completeOrder) {
                    this.currentMethodologyFormData.completeOrder.values = currentMethodologyData.algorithms.completeOrder.values
                    for (let i = 0; i < this.currentMethodologyFormData.completeOrder.values.length; i++) {
                        const item = this.currentMethodologyFormData.completeOrder.values[i];
                        item.id = this.makeId();
                    }
                    this.currentMethodologyFormData.completeOrder.intervals = this.currentMethodologyFormData.completeOrder.values.length
                } else {
                    this.currentMethodologyFormData.completeOrder.values = [];
                    this.currentMethodologyFormData.completeOrder.intervals = 0;
                    this.currentMethodologyFormData.completeOrder.transitionMember = ''
                }
                if (this.$refs.form) this.$refs.form.resetForm();
                this.disableBonusSettings();
            },
            resetFormToCurrent() {
                if (this.currentMethodology) this.updateForm(this.currentMethodology);
            },
            setChangedValue(e, index, algo, type) {
                let val = e.target.value.replace(',', '.');
                this.currentMethodologyFormData[algo].values[index][type] = val;
                e.target.className = 'bonus-table__input';
                if (isNaN(val)) {
                    e.target.className = 'bonus-table__input not-valid';
                }
            },
            addRow(algo) {
                const row = {
                    rating: 0,
                    bonus: 0,
                    id: this.makeId()
                };
                if (algo === 'inRangeValues') {
                    row.min = 0;
                }
                this.currentMethodologyFormData[algo].values.push(row);
                this.currentMethodologyFormData[algo].intervals = this.currentMethodologyFormData[algo].values.length
            },
            removeRow(algo, index) {
                this.currentMethodologyFormData[algo].values.splice(index, 1);
                this.currentMethodologyFormData[algo].intervals = this.currentMethodologyFormData[algo].values.length
            },
            async selectHandler(data) {
                this.isDataPending = true;
                await this.$store.dispatch(GET_BONUS, data.uuid);
                this.isDataPending = false;
            },
            async submitEdit() {
                this.validateForm();
                if (this.isCurrentMethodologyFormValid) {
                    this.$store.dispatch(UPDATE_BONUS, {
                        uuid: this.currentMethodologyFormData.uuid,
                        payload: this.preparedFormData
                    })
                        .then((res) => {
                            if (res.error) {
                                console.log('Server responded with an error: ', res);
                                this.$refs['modal-error'].open();
                            } else {
                                this.$refs['modal-success'].open();
                                this.$store.dispatch(GET_BONUSES);
                            }
                        })
                        .catch((e) => {
                            throw new Error(e);
                        });
                }
            },
            async deleteCurrentBonusMethodology() {
                await this.$store.dispatch(DELETE_BONUS);
                this.$refs['modal-delete'].close();
                this.$store.dispatch(GET_BONUSES);
                this.resetFormToCurrent();
            }
        },
        watch: {
            currentMethodology: function (val) {
                if (val) {
                    this.updateForm(val);
                }
            },
            'currentMethodologyFormData.inRangeValues.period': function (val) {
                if (isNaN(+val) || val === '') {
                    this.currentMethodologyFormData.inRangeValues.periodIsValid = false;
                } else {
                    this.currentMethodologyFormData.inRangeValues.periodIsValid = true;
                }
            },
            'currentMethodologyFormData.ratingIncrease.transitionMember': function (val) {
                if (isNaN(+val) || val === '') {
                    this.currentMethodologyFormData.ratingIncrease.transitionMemberIsValid = false;
                } else {
                    this.currentMethodologyFormData.ratingIncrease.transitionMemberIsValid = true;
                }
            }
        }
    }
</script>

<style lang="scss" scoped>
    .no-item {
        color: #9c9c9c;
        padding: 40px 20px;
        text-align: center;
        position: sticky;
        top: 20px;
        text-transform: uppercase;
        font-weight: 700;
        font-size: 24px;
    }

    .settings-wrapper {
        padding: 13px 0;
    }

    .settings-gutter {
        padding: 0 16px;
    }

    .settings-form {
        border-bottom: 2px dotted #99b7e9;
        padding-bottom: 20px;
    }

    .settings-title {
        font-size: 24px;
        line-height: 36px;
        letter-spacing: .4px;
        color: #191e32;
        margin-bottom: 20px;
    }

    .input-container {
        margin-bottom: 20px;
    }

    .inputs-flex-container {
        display: flex;
        justify-content: space-between;
        margin-bottom: 10px;
    }

    .add-bonus {
        padding: 15px 0
    }

    .add-bonus__switch {
        margin-bottom: 10px;
    }

    .add-bonus__input-wrapper {
        width: 48%
    }

    .add-bonus__header {
        display: block;
        font-size: 1.5em;
        font-weight: bold;
        line-height: 1.2;
        margin-bottom: 10px;
    }

    .add-bonus__input-wrapper {
        position: relative;
    }

    .add-bonus__remove-row-cell {
        width: 30px;

        &.disabled {
            background-color: #f4f4f5;
        }
    }

    .add-bonus__remove-row {
        width: 22px;
        height: 22px;
        font-size: 22px;
        cursor: pointer;
    }

    .add-bonus__add-row {
        position: absolute;
        width: 22px;
        height: 22px;
        right: 16px;
        top: 50%;
        transform: translateY(-50%);
        font-size: 22px;
        cursor: pointer;
    }

    .bonus-table {
        width: 100%;
        border-collapse: collapse;
        border-spacing: 0;
    }

    .bonus-table__header-item {
        font-size: 11px;
        line-height: 15px;
        font-weight: 400;
        letter-spacing: .4px;
        text-transform: uppercase;
        min-height: 40px;
        padding: 8px 14px;
    }

    .bonus-table__input {
        height: 40px;
        display: block;
        width: 100%;
        border: none;
        font-style: normal;
        font-weight: 400;
        font-size: 16px;
        line-height: 20px;
        letter-spacing: .2px;
        text-align: left;
        background-color: transparent;
        outline: none;
        padding: 0 14px;

        &:disabled {
            border-color: #f4f4f5;
            background-color: #f4f4f5;
        }

        &.not-valid {
            color: #E62D3B;
        }
    }

    .bonus-table__input-row {
        border-top: 1px solid #e5edf9;
        border-bottom: 1px solid #e5edf9;
    }

    .alert-container {
        margin-top: 20px;
        padding: 0 15px;
    }

    .network-status-alert {
        position: absolute;
        right: 15px;
        top: 20px;
        width: 220px;
        z-index: 100;
    }

    .bonuses-page {
        width: 100%;
        position: relative;
    }

    .ratings {
        &__column {
            height: 100%;
        }
    }

    .action {
        display: block;
    }

    .delete-button-container {
        padding-top: 18px;
    }

    .color_green {
        //noinspection CssInvalidPseudoSelector
        &::v-deep {
            .label-text {
                color: green !important;
            }
        }
    }

    .color_red {
        //noinspection CssInvalidPseudoSelector
        &::v-deep {
            .label-text {
                color: red !important;
            }
        }
    }

    .edit-method {
        display: flex;
        &__input {
            width: 80%;
            margin: 0;
        }
        &__check {
            align-self: center;
            margin: auto;
        }
    }
</style>
